Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class TreeMultiset<E>

    java.lang.Object
      java.util.AbstractCollection<E>
          com.google.common.collect.TreeMultiset<E>

All Implemented Interfaces:
  Multiset<E>, Serializable, Iterable<E>, Collection<E>

    public final class TreeMultiset<E>

extends AbstractCollection<E>

A multiset which maintains the ordering of its elements, according to either their natural order or an explicit `Comparator`. In all cases, this implementation uses `Comparable.compareTo(T)` or `Comparator.compare(T, T)` instead of `Object.equals(java.lang.Object)` to determine equivalence of instances.

Warning: The comparison must be consistent with equals as explained by the `Comparable` class specification. Otherwise, the resulting multiset will violate the `Collection` contract, which it is specified in terms of `Object.equals(java.lang.Object)`.

Author:
  Neal Kanodia, Jared Levy
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from interface com.google.common.collect.Multiset
`Multiset.Entry<E>`

Method Summary
`boolean` | `add(E element)` Ensures that this collection contains the specified element (optional operation).
`int` | `add(E element, int occurrences)` Adds a number of occurrences of an element to this multiset.
`boolean` | `addAll(Collection<? extends E> elementsToAdd)` Adds all of the elements in the specified collection to this collection (optional operation).
`void` | `clear()` Removes all of the elements from this collection (optional operation).
`boolean` | `contains(Object element)` Returns `true` if this collection contains the specified element.
`boolean` | `containsAll(Collection<?> elements)` Returns `true` if this collection contains all of the elements in the specified collection.
`int` | `count(Object element)` Returns the number of occurrences of an element in this multiset (the count of the element).
`static
`<E extends Comparable> TreeMultiset<E>`
` | `create()` Creates a new, empty multiset, sorted according to the elements' natural order.
`static
`<E> TreeMultiset<E>`
` | `create(Comparator<? super E> comparator)` Creates a new, empty multiset, sorted according to the specified comparator.
`static
`<E extends Comparable> TreeMultiset<E>`
` | `create(Iterable<? extends E> elements)` Creates an empty multiset containing the given initial elements, sorted according to the elements' natural order.
`SortedSet<E>` | `elementSet()` Returns the set of distinct elements contained in this multiset.
`Set<Multiset.Entry<E>>` | `entrySet()` Returns a view of the contents of this multiset, grouped into `Multiset.Entry` instances, each providing an element of the multiset and the count of that element.
`boolean` | `equals(Object object)` Indicates whether some other object is "equal to" this one.
`int` | `hashCode()` Returns a hash code value for the object.
`boolean` | `isEmpty()` Returns `true` if this collection contains no elements.
`Iterator<E>` | `iterator()` Returns an iterator over the elements contained in this collection.
`boolean` | `remove(Object element)` Removes a single instance of the specified element from this collection, if it is present (optional operation).
`int` | `remove(Object element, int occurrences)` Removes a number of occurrences of the specified element from this multiset.
`boolean` | `removeAll(Collection<?> elementsToRemove)` Removes all of this collection's elements that are also contained in the specified collection (optional operation).
`boolean` | `retainAll(Collection<?> elementsToRetain)` Retains only the elements in this collection that are contained in the specified collection (optional operation).
`int` | `setCount(E element, int count)` Adds or removes the necessary occurrences of an element such that the element attains the desired count.
`boolean` | `setCount(E element, int oldCount, int newCount)` Conditionally sets the count of an element to a new value, as described in `Multiset.setCount(Object, int)`, provided that the element has the expected current count.
`int` | `size()` Returns the number of elements in this collection.
`String` | `toString()` Returns a string representation of this collection.

Methods inherited from class java.util.AbstractCollection
`toArray, toArray`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Collection
`toArray, toArray`

Method Detail

### create

    public static <E extends Comparable> TreeMultiset<E> create()

  Creates a new, empty multiset, sorted according to the elements' natural order. All elements inserted into the multiset must implement the `Comparable` interface. Furthermore, all such elements must be mutually comparable: `e1.compareTo(e2)` must not throw a `ClassCastException` for any elements `e1` and `e2` in the multiset. If the user attempts to add an element to the multiset that violates this constraint (for example, the user attempts to add a string element to a set whose elements are integers), the `add(Object)` call will throw a `ClassCastException`.

  The type specification is `<E extends Comparable>`, instead of the more specific `<E extends Comparable<? super E>>`, to support classes defined without generics.

### create

    public static <E> TreeMultiset<E> create(Comparator<? super E> comparator)

  Creates a new, empty multiset, sorted according to the specified comparator. All elements inserted into the multiset must be mutually comparable by the specified comparator: `comparator.compare(e1, e2)` must not throw a `ClassCastException` for any elements `e1` and `e2` in the multiset. If the user attempts to add an element to the multiset that violates this constraint, the `add(Object)` call will throw a `ClassCastException`.

  Parameters:
    `comparator` - the comparator that will be used to sort this multiset. A null value indicates that the elements' natural ordering should be used.

### create

    public static <E extends Comparable> TreeMultiset<E> create(Iterable<? extends E> elements)

  Creates an empty multiset containing the given initial elements, sorted according to the elements' natural order.

  The type specification is `<E extends Comparable>`, instead of the more specific `<E extends Comparable<? super E>>`, to support classes defined without generics.

### elementSet

    public SortedSet<E> elementSet()

  Returns the set of distinct elements contained in this multiset. The element set is backed by the same data as the multiset, so any change to either is immediately reflected in the other. The order of the elements in the element set is unspecified.

  If the element set supports any removal operations, these necessarily cause all occurrences of the removed element(s) to be removed from the multiset. Implementations are not expected to support the add operations, although this is possible.

  A common use for the element set is to find the number of distinct elements in the multiset: `elementSet().size()`.

  In `TreeMultiset`, the return type of this method is narrowed from `Set` to `SortedSet`.

  Specified by:
    `elementSet` in interface `Multiset<E>`
  Returns:
    a view of the set of distinct elements in this multiset

### count

    public int count(@Nullable
                     Object element)

  Description copied from interface: `Multiset`
  Returns the number of occurrences of an element in this multiset (the count of the element). Note that for an `Object.equals(java.lang.Object)`-based multiset, this gives the same result as `Collections.frequency(java.util.Collection, java.lang.Object)` (which would presumably perform more poorly).

  Note: the utility method `Iterables.frequency(java.lang.Iterable, java.lang.Object)` generalizes this operation; it correctly delegates to this method when dealing with a multiset, but it can also accept any other iterable type.

  Specified by:
    `count` in interface `Multiset<E>`
  Parameters:
    `element` - the element to count occurrences of
  Returns:
    the number of occurrences of the element in this multiset; possibly zero but never negative

### entrySet

    public Set<Multiset.Entry<E>> entrySet()

  Returns a view of the contents of this multiset, grouped into `Multiset.Entry` instances, each providing an element of the multiset and the count of that element. This set contains exactly one entry for each distinct element in the multiset (thus it always has the same size as the `Multiset.elementSet()`). The order of the elements in the element set is unspecified.

  The entry set is backed by the same data as the multiset, so any change to either is immediately reflected in the other. However, multiset changes may or may not be reflected in any `Entry` instances already retrieved from the entry set (this is implementation-dependent). Furthermore, implementations are not required to support modifications to the entry set at all, and the `Entry` instances themselves don't even have methods for modification. See the specific implementation class for more details on how its entry set handles modifications.

  Invoking `Multiset.Entry.getCount()` on an entry in the returned set always returns the current count of that element in the multiset, as opposed to the count at the time the entry was retrieved.

  Specified by:
    `entrySet` in interface `Multiset<E>`
  Returns:
    a set of entries representing the data of this multiset

### size

    public int size()

  Description copied from interface: `java.util.Collection`
  Returns the number of elements in this collection. If this collection contains more than `Integer.MAX_VALUE` elements, returns `Integer.MAX_VALUE`.

  Specified by:
    `size` in interface `Collection<E>`
  Returns:
    the number of elements in this collection

### iterator

    public Iterator<E> iterator()

  Description copied from class: `java.util.AbstractCollection`
  Returns an iterator over the elements contained in this collection.

  Specified by:
    `iterator` in interface `Multiset<E>`
  Specified by:
    `iterator` in interface `Iterable<E>`
  Specified by:
    `iterator` in interface `Collection<E>`
  Returns:
    an iterator over the elements contained in this collection

### add

    public int add(@Nullable
                   E element,
                   int occurrences)

  Adds a number of occurrences of an element to this multiset. Note that if `occurrences == 1`, this method has the identical effect to `Multiset.add(Object)`. This method is functionally equivalent (except in the case of overflow) to the call `addAll(Collections.nCopies(element, occurrences))`, which would presumably perform much more poorly.

  Specified by:
    `add` in interface `Multiset<E>`
  Parameters:
    `element` - the element to add occurrences of; may be `null` only if explicitly allowed by the implementation
    `occurrences` - the number of occurrences of the element to add. May be zero, in which case no change will be made.
  Returns:
    the count of the element before the operation; possibly zero
  Throws:
    `IllegalArgumentException` - if the call would result in more than `Integer.MAX_VALUE` occurrences of `element` in this multiset.

### remove

    public int remove(@Nullable
                      Object element,
                      int occurrences)

  Description copied from interface: `Multiset`
  Removes a number of occurrences of the specified element from this multiset. If the multiset contains fewer than this number of occurrences to begin with, all occurrences will be removed. Note that if `occurrences == 1`, this is functionally equivalent to the call `remove(element)`.

  Specified by:
    `remove` in interface `Multiset<E>`
  Parameters:
    `element` - the element to conditionally remove occurrences of
    `occurrences` - the number of occurrences of the element to remove. May be zero, in which case no change will be made.
  Returns:
    the count of the element before the operation; possibly zero

### setCount

    public int setCount(E element,
                        int count)

  Description copied from interface: `Multiset`
  Adds or removes the necessary occurrences of an element such that the element attains the desired count.

  Specified by:
    `setCount` in interface `Multiset<E>`
  Parameters:
    `element` - the element to add or remove occurrences of; may be null only if explicitly allowed by the implementation
    `count` - the desired count of the element in this multiset
  Returns:
    the count of the element before the operation; possibly zero

### isEmpty

    public boolean isEmpty()

  Description copied from class: `java.util.AbstractCollection`
  Returns `true` if this collection contains no elements.

  This implementation returns `size() == 0`.

  Specified by:
    `isEmpty` in interface `Collection<E>`
  Overrides:
    `isEmpty` in class `AbstractCollection<E>`
  Returns:
    `true` if this collection contains no elements

### contains

    public boolean contains(@Nullable
                            Object element)

  Description copied from class: `java.util.AbstractCollection`
  Returns `true` if this collection contains the specified element. More formally, returns `true` if and only if this collection contains at least one element `e` such that `(o==null ? e==null : o.equals(e))`.

  This implementation iterates over the elements in the collection, checking each element in turn for equality with the specified element.

  Specified by:
    `contains` in interface `Multiset<E>`
  Specified by:
    `contains` in interface `Collection<E>`
  Overrides:
    `contains` in class `AbstractCollection<E>`
  Parameters:
    `element` - element whose presence in this collection is to be tested
  Returns:
    `true` if this collection contains the specified element

### add

    public boolean add(@Nullable
                       E element)

  Description copied from class: `java.util.AbstractCollection`
  Ensures that this collection contains the specified element (optional operation). Returns `true` if this collection changed as a result of the call. (Returns `false` if this collection does not permit duplicates and already contains the specified element.)

  Collections that support this operation may place limitations on what elements may be added to this collection. In particular, some collections will refuse to add `null` elements, and others will impose restrictions on the type of elements that may be added. Collection classes should clearly specify in their documentation any restrictions on what elements may be added.

  If a collection refuses to add a particular element for any reason other than that it already contains the element, it must throw an exception (rather than returning `false`). This preserves the invariant that a collection always contains the specified element after this call returns.

  This implementation always throws an `UnsupportedOperationException`.

  Specified by:
    `add` in interface `Multiset<E>`
  Specified by:
    `add` in interface `Collection<E>`
  Overrides:
    `add` in class `AbstractCollection<E>`
  Parameters:
    `element` - element whose presence in this collection is to be ensured
  Returns:
    `true` if this collection changed as a result of the call

### remove

    public boolean remove(Object element)

  Description copied from class: `java.util.AbstractCollection`
  Removes a single instance of the specified element from this collection, if it is present (optional operation). More formally, removes an element `e` such that `(o==null ? e==null : o.equals(e))`, if this collection contains one or more such elements. Returns `true` if this collection contained the specified element (or equivalently, if this collection changed as a result of the call).

  This implementation iterates over the collection looking for the specified element. If it finds the element, it removes the element from the collection using the iterator's remove method.

  Note that this implementation throws an `UnsupportedOperationException` if the iterator returned by this collection's iterator method does not implement the `remove` method and this collection contains the specified object.

  Specified by:
    `remove` in interface `Multiset<E>`
  Specified by:
    `remove` in interface `Collection<E>`
  Overrides:
    `remove` in class `AbstractCollection<E>`
  Parameters:
    `element` - element to be removed from this collection, if present
  Returns:
    `true` if an element was removed as a result of this call

### setCount

    public boolean setCount(E element,
                            int oldCount,
                            int newCount)

  Description copied from interface: `Multiset`
  Conditionally sets the count of an element to a new value, as described in `Multiset.setCount(Object, int)`, provided that the element has the expected current count. If the current count is not `oldCount`, no change is made.

  Specified by:
    `setCount` in interface `Multiset<E>`
  Parameters:
    `element` - the element to conditionally set the count of; may be null only if explicitly allowed by the implementation
    `oldCount` - the expected present count of the element in this multiset
    `newCount` - the desired count of the element in this multiset
  Returns:
    `true` if the condition for modification was met. This implies that the multiset was indeed modified, unless `oldCount == newCount`.

### containsAll

    public boolean containsAll(Collection<?> elements)

  Description copied from class: `java.util.AbstractCollection`
  Returns `true` if this collection contains all of the elements in the specified collection.

  This implementation iterates over the specified collection, checking each element returned by the iterator in turn to see if it's contained in this collection. If all elements are so contained `true` is returned, otherwise `false`.

  Specified by:
    `containsAll` in interface `Multiset<E>`
  Specified by:
    `containsAll` in interface `Collection<E>`
  Overrides:
    `containsAll` in class `AbstractCollection<E>`
  Parameters:
    `elements` - collection to be checked for containment in this collection
  Returns:
    `true` if this collection contains all of the elements in the specified collection
  See Also:
    `AbstractCollection.contains(Object)`

### addAll

    public boolean addAll(Collection<? extends E> elementsToAdd)

  Description copied from class: `java.util.AbstractCollection`
  Adds all of the elements in the specified collection to this collection (optional operation). The behavior of this operation is undefined if the specified collection is modified while the operation is in progress. (This implies that the behavior of this call is undefined if the specified collection is this collection, and this collection is nonempty.)

  This implementation iterates over the specified collection, and adds each object returned by the iterator to this collection, in turn.

  Note that this implementation will throw an `UnsupportedOperationException` unless `add` is overridden (assuming the specified collection is non-empty).

  Specified by:
    `addAll` in interface `Collection<E>`
  Overrides:
    `addAll` in class `AbstractCollection<E>`
  Parameters:
    `elementsToAdd` - collection containing elements to be added to this collection
  Returns:
    `true` if this collection changed as a result of the call
  See Also:
    `AbstractCollection.add(Object)`

### removeAll

    public boolean removeAll(Collection<?> elementsToRemove)

  Description copied from class: `java.util.AbstractCollection`
  Removes all of this collection's elements that are also contained in the specified collection (optional operation). After this call returns, this collection will contain no elements in common with the specified collection.

  This implementation iterates over this collection, checking each element returned by the iterator in turn to see if it's contained in the specified collection. If it's so contained, it's removed from this collection with the iterator's `remove` method.

  Note that this implementation will throw an `UnsupportedOperationException` if the iterator returned by the `iterator` method does not implement the `remove` method and this collection contains one or more elements in common with the specified collection.

  Specified by:
    `removeAll` in interface `Multiset<E>`
  Specified by:
    `removeAll` in interface `Collection<E>`
  Overrides:
    `removeAll` in class `AbstractCollection<E>`
  Parameters:
    `elementsToRemove` - collection containing elements to be removed from this collection
  Returns:
    `true` if this collection changed as a result of the call
  See Also:
    `AbstractCollection.remove(Object)`, `AbstractCollection.contains(Object)`

### retainAll

    public boolean retainAll(Collection<?> elementsToRetain)

  Description copied from class: `java.util.AbstractCollection`
  Retains only the elements in this collection that are contained in the specified collection (optional operation). In other words, removes from this collection all of its elements that are not contained in the specified collection.

  This implementation iterates over this collection, checking each element returned by the iterator in turn to see if it's contained in the specified collection. If it's not so contained, it's removed from this collection with the iterator's `remove` method.

  Note that this implementation will throw an `UnsupportedOperationException` if the iterator returned by the `iterator` method does not implement the `remove` method and this collection contains one or more elements not present in the specified collection.

  Specified by:
    `retainAll` in interface `Multiset<E>`
  Specified by:
    `retainAll` in interface `Collection<E>`
  Overrides:
    `retainAll` in class `AbstractCollection<E>`
  Parameters:
    `elementsToRetain` - collection containing elements to be retained in this collection
  Returns:
    `true` if this collection changed as a result of the call
  See Also:
    `AbstractCollection.remove(Object)`, `AbstractCollection.contains(Object)`

### clear

    public void clear()

  Description copied from class: `java.util.AbstractCollection`
  Removes all of the elements from this collection (optional operation). The collection will be empty after this method returns.

  This implementation iterates over this collection, removing each element using the `Iterator.remove` operation. Most implementations will probably choose to override this method for efficiency.

  Note that this implementation will throw an `UnsupportedOperationException` if the iterator returned by this collection's `iterator` method does not implement the `remove` method and this collection is non-empty.

  Specified by:
    `clear` in interface `Collection<E>`
  Overrides:
    `clear` in class `AbstractCollection<E>`

### equals

    public boolean equals(@Nullable
                          Object object)

  Indicates whether some other object is "equal to" this one.

  The `equals` method implements an equivalence relation on non-null object references:

  - It is reflexive: for any non-null reference value `x`, `x.equals(x)` should return `true`.
  - It is symmetric: for any non-null reference values `x` and `y`, `x.equals(y)` should return `true` if and only if `y.equals(x)` returns `true`.
  - It is transitive: for any non-null reference values `x`, `y`, and `z`, if `x.equals(y)` returns `true` and `y.equals(z)` returns `true`, then `x.equals(z)` should return `true`.
  - It is consistent: for any non-null reference values `x` and `y`, multiple invocations of `x.equals(y)` consistently return `true` or consistently return `false`, provided no information used in `equals` comparisons on the objects is modified.
  - For any non-null reference value `x`, `x.equals(null)` should return `false`.

  The `equals` method for class `Object` implements the most discriminating possible equivalence relation on objects; that is, for any non-null reference values `x` and `y`, this method returns `true` if and only if `x` and `y` refer to the same object (`x == y` has the value `true`).

  Note that it is generally necessary to override the `hashCode` method whenever this method is overridden, so as to maintain the general contract for the `hashCode` method, which states that equal objects must have equal hash codes.

  This implementation returns `true` if `other` is a multiset of the same size and if, for each element, the two multisets have the same count.

  Specified by:
    `equals` in interface `Multiset<E>`
  Specified by:
    `equals` in interface `Collection<E>`
  Overrides:
    `equals` in class `Object`
  Parameters:
    `object` - the reference object with which to compare.
  Returns:
    `true` if this object is the same as the obj argument; `false` otherwise.
  See Also:
    `Object.hashCode()`, `Hashtable`

### hashCode

    public int hashCode()

  Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by `java.util.Hashtable`.

  The general contract of `hashCode` is:

  - Whenever it is invoked on the same object more than once during an execution of a Java application, the `hashCode` method must consistently return the same integer, provided no information used in `equals` comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application.
  - If two objects are equal according to the `equals(Object)` method, then calling the `hashCode` method on each of the two objects must produce the same integer result.
  - It is not required that if two objects are unequal according to the `Object.equals(java.lang.Object)` method, then calling the `hashCode` method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables.

  As much as is reasonably practical, the hashCode method defined by class `Object` does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)

  This implementation returns the hash code of `Multiset.entrySet()`.

  Specified by:
    `hashCode` in interface `Multiset<E>`
  Specified by:
    `hashCode` in interface `Collection<E>`
  Overrides:
    `hashCode` in class `Object`
  Returns:
    a hash code value for this object.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

### toString

    public String toString()

  Returns a string representation of this collection. The string representation consists of a list of the collection's elements in the order they are returned by its iterator, enclosed in square brackets (`"[]"`). Adjacent elements are separated by the characters `", "` (comma and space). Elements are converted to strings as by `String.valueOf(Object)`.

  This implementation returns the result of invoking `toString` on `Multiset.entrySet()`.

  Specified by:
    `toString` in interface `Multiset<E>`
  Overrides:
    `toString` in class `AbstractCollection<E>`
  Returns:
    a string representation of this collection

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD